Subject: Re: [PATCH net] net: neighbour: make sure the handler has finished before kfree neighbour

From: Ding Tianhong <[email-masked]>
Date: Sun, 01 Dec 2013 10:43:10 +0800

于 2013/12/1 5:27, David Miller 写道:
> From: Ding Tianhong <[email-masked]>
> Date: Thu, 28 Nov 2013 20:28:52 +0800
> 
>> I have met the oops in Suse11 SP2, the kernel is 2.6.32.59-0.7-default:
> 
> This doesn't make any sense.
> 
> If this actually was the reason, then del_timer() would have returned true,
> and thus neigh_del_timer() would have returned "1" and you would have
> seen the "Impossible event" log message that neigh_destroy() prints out.
> 
> You may think the cause is a pending timer, but the data you've provided
> does not support this at all.
> 
> And if it isn't happening, your patch removing that warning is wrong.
> 
> Furthermore, if this change to use del_timer_sync() is correct, it
> probably belongs in neigh_del_timer() because all of it's other callers
> expect the timer to not be running and that all references to the object
> are stable after such calls.
> 
> I'm not applying this, you really need to pursue this bug fix more
> cleanly and more thoroughly because it's a non-trivial issue.
> 
> Thanks.

ok，thanks for the advice, I would like to think it over and make it better.

Regards
Ding

> --
> To unsubscribe from this list: send the line "unsubscribe netdev" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html
>